From 7c29546739e60197982bfe9d229ca7ac4d493475 Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Apr 25 2020 20:13:43 +0000
Subject: [PATCH 357/2232] Revert some unrelated changes from PR 67


---

diff --git a/Cargo.toml b/Cargo.toml
index 95cd87d..f497482 100644
--- a/Cargo.toml
+++ b/Cargo.toml
@@ -17,7 +17,6 @@ travis-ci = { repository = "dtolnay/cxx" }
 [dependencies]
 anyhow = "1.0"
 cc = "1.0.49"
-codespan = "0.7"
 codespan-reporting = "0.9"
 cxxbridge-macro = { version = "=0.2.10", path = "macro" }
 link-cplusplus = "1.0"
diff --git a/demo-cxx/demo.cc b/demo-cxx/demo.cc
index 0274ff1..4940834 100644
--- a/demo-cxx/demo.cc
+++ b/demo-cxx/demo.cc
@@ -9,7 +9,7 @@ ThingC::ThingC(std::string appname) : appname(std::move(appname)) {}
 
 ThingC::~ThingC() { std::cout << "done with ThingC" << std::endl; }
 
-std::unique_ptr<ThingC> make_demo(::rust::Str appname) {
+std::unique_ptr<ThingC> make_demo(rust::Str appname) {
   return std::unique_ptr<ThingC>(new ThingC(std::string(appname)));
 }
 
diff --git a/demo-cxx/demo.h b/demo-cxx/demo.h
index 29a3ba1..2c9f1c0 100644
--- a/demo-cxx/demo.h
+++ b/demo-cxx/demo.h
@@ -17,7 +17,7 @@ public:
 struct SharedThing;
 struct JsonBlob;
 
-std::unique_ptr<ThingC> make_demo(::rust::Str appname);
+std::unique_ptr<ThingC> make_demo(rust::Str appname);
 const std::string &get_name(const ThingC &thing);
 std::unique_ptr<std::vector<uint8_t>> do_thing(SharedThing state);
 JsonBlob get_jb(const ::rust::Vec<uint8_t> &vec);
diff --git a/gen/write.rs b/gen/write.rs
index a74833f..8a60f17 100644
--- a/gen/write.rs
+++ b/gen/write.rs
@@ -44,7 +44,7 @@ pub(super) fn gen(
             Api::Struct(strct) => write_struct_decl(out, &strct.ident),
             Api::CxxType(ety) => write_struct_using(out, &ety.ident),
             Api::RustType(ety) => write_struct_decl(out, &ety.ident),
-            _ => (),
+            _ => {}
         }
     }
 
@@ -127,7 +127,7 @@ fn write_includes(out: &mut OutFile, types: &Types) {
             Type::UniquePtr(_) => out.include.memory = true,
             Type::Vector(_) => out.include.vector = true,
             Type::SliceRefU8(_) => out.include.cstdint = true,
-            _ => (),
+            _ => {}
         }
     }
 }
@@ -139,6 +139,7 @@ fn write_include_cxxbridge(out: &mut OutFile, apis: &[Api], types: &Types) {
     let mut needs_rust_box = false;
     let mut needs_rust_vec = false;
     let mut needs_rust_fn = false;
+    let mut needs_rust_isize = false;
     for ty in types {
         match ty {
             Type::RustBox(_) => {
@@ -160,6 +161,10 @@ fn write_include_cxxbridge(out: &mut OutFile, apis: &[Api], types: &Types) {
             Type::Slice(_) | Type::SliceRefU8(_) => {
                 needs_rust_slice = true;
             }
+            ty if ty == Isize => {
+                out.include.base_tsd = true;
+                needs_rust_isize = true;
+            }
             ty if ty == RustString => {
                 out.include.array = true;
                 out.include.cstdint = true;
@@ -219,6 +224,7 @@ fn write_include_cxxbridge(out: &mut OutFile, apis: &[Api], types: &Types) {
         || needs_rust_vec
         || needs_rust_fn
         || needs_rust_error
+        || needs_rust_isize
         || needs_unsafe_bitcopy
         || needs_manually_drop
         || needs_maybe_uninit
@@ -239,6 +245,7 @@ fn write_include_cxxbridge(out: &mut OutFile, apis: &[Api], types: &Types) {
     write_header_section(out, needs_rust_vec, "CXXBRIDGE02_RUST_VEC");
     write_header_section(out, needs_rust_fn, "CXXBRIDGE02_RUST_FN");
     write_header_section(out, needs_rust_error, "CXXBRIDGE02_RUST_ERROR");
+    write_header_section(out, needs_rust_isize, "CXXBRIDGE02_RUST_ISIZE");
     write_header_section(out, needs_unsafe_bitcopy, "CXXBRIDGE02_RUST_BITCOPY");
 
     if needs_manually_drop {
diff --git a/include/cxx.h b/include/cxx.h
index 0a664d0..31b3dde 100644
--- a/include/cxx.h
+++ b/include/cxx.h
@@ -256,11 +256,14 @@ private:
 };
 #endif // CXXBRIDGE02_RUST_ERROR
 
+#ifndef CXXBRIDGE02_RUST_ISIZE
+#define CXXBRIDGE02_RUST_ISIZE
 #if defined(_WIN32)
 using isize = SSIZE_T;
 #else
 using isize = ssize_t;
 #endif
+#endif // CXXBRIDGE02_RUST_ISIZE
 
 std::ostream &operator<<(std::ostream &, const String &);
 std::ostream &operator<<(std::ostream &, const Str &);
diff --git a/macro/Cargo.toml b/macro/Cargo.toml
index 99ae923..ca0e326 100644
--- a/macro/Cargo.toml
+++ b/macro/Cargo.toml
@@ -19,7 +19,7 @@ quote = "1.0"
 syn = { version = "1.0", features = ["full"] }
 
 [dev-dependencies]
-cxx = { version = "0.2.7-alpha-1", path = ".." }
+cxx = { version = "0.2", path = ".." }
 
 [package.metadata.docs.rs]
 targets = ["x86_64-unknown-linux-gnu"]
diff --git a/tests/ffi/lib.rs b/tests/ffi/lib.rs
index 27f5f6d..da0040a 100644
--- a/tests/ffi/lib.rs
+++ b/tests/ffi/lib.rs
@@ -44,7 +44,6 @@ pub mod ffi {
         fn c_take_unique_ptr_vector_u8(s: UniquePtr<Vector<u8>>);
         fn c_take_unique_ptr_vector_f64(s: UniquePtr<Vector<f64>>);
         fn c_take_unique_ptr_vector_shared(s: UniquePtr<Vector<Shared>>);
-
         fn c_take_vec_u8(v: &Vec<u8>);
         fn c_take_vec_shared(v: &Vec<Shared>);
         fn c_take_callback(callback: fn(String) -> usize);
@@ -52,8 +51,6 @@ pub mod ffi {
         fn c_try_return_void() -> Result<()>;
         fn c_try_return_primitive() -> Result<usize>;
         fn c_fail_return_primitive() -> Result<usize>;
-        fn c_try_return_string() -> Result<UniquePtr<CxxString>>;
-        fn c_fail_return_string() -> Result<UniquePtr<CxxString>>;
         fn c_try_return_box() -> Result<Box<R>>;
         fn c_try_return_ref(s: &String) -> Result<&String>;
         fn c_try_return_str(s: &str) -> Result<&str>;
diff --git a/tests/ffi/tests.cc b/tests/ffi/tests.cc
index 446486d..a8d7018 100644
--- a/tests/ffi/tests.cc
+++ b/tests/ffi/tests.cc
@@ -192,14 +192,6 @@ size_t c_try_return_primitive() { return 2020; }
 
 size_t c_fail_return_primitive() { throw std::logic_error("logic error"); }
 
-std::unique_ptr<std::string> c_try_return_string() {
-  return std::unique_ptr<std::string>(new std::string("ok"));
-}
-
-std::unique_ptr<std::string> c_fail_return_string() {
-  throw std::logic_error("logic error getting string");
-}
-
 rust::Box<R> c_try_return_box() { return c_return_box(); }
 
 const rust::String &c_try_return_ref(const rust::String &s) { return s; }
diff --git a/tests/ffi/tests.h b/tests/ffi/tests.h
index d2ce44e..876e3c5 100644
--- a/tests/ffi/tests.h
+++ b/tests/ffi/tests.h
@@ -46,7 +46,6 @@ void c_take_unique_ptr_string(std::unique_ptr<std::string> s);
 void c_take_unique_ptr_vector_u8(std::unique_ptr<std::vector<uint8_t>> v);
 void c_take_unique_ptr_vector_f64(std::unique_ptr<std::vector<double>> v);
 void c_take_unique_ptr_vector_shared(std::unique_ptr<std::vector<Shared>> v);
-
 void c_take_vec_u8(const ::rust::Vec<uint8_t> &v);
 void c_take_vec_shared(const ::rust::Vec<Shared> &v);
 void c_take_callback(rust::Fn<size_t(rust::String)> callback);
@@ -54,8 +53,6 @@ void c_take_callback(rust::Fn<size_t(rust::String)> callback);
 void c_try_return_void();
 size_t c_try_return_primitive();
 size_t c_fail_return_primitive();
-std::unique_ptr<std::string> c_try_return_string();
-std::unique_ptr<std::string> c_fail_return_string();
 rust::Box<R> c_try_return_box();
 const rust::String &c_try_return_ref(const rust::String &);
 rust::Str c_try_return_str(rust::Str);
diff --git a/tests/test.rs b/tests/test.rs
index 17fcfca..b33c675 100644
--- a/tests/test.rs
+++ b/tests/test.rs
@@ -81,18 +81,6 @@ fn test_c_try_return() {
         "logic error",
         ffi::c_fail_return_primitive().unwrap_err().what(),
     );
-    assert_eq!(
-        "ok",
-        ffi::c_try_return_string()
-            .unwrap()
-            .as_ref()
-            .unwrap()
-            .to_string()
-    );
-    assert_eq!(
-        "logic error getting string",
-        ffi::c_fail_return_string().unwrap_err().what(),
-    );
     assert_eq!(2020, *ffi::c_try_return_box().unwrap());
     assert_eq!("2020", *ffi::c_try_return_ref(&"2020".to_owned()).unwrap());
     assert_eq!("2020", ffi::c_try_return_str("2020").unwrap());
@@ -125,9 +113,7 @@ fn test_c_take() {
     check!(ffi::c_take_unique_ptr_vector_shared(
         ffi::c_return_unique_ptr_vector_shared()
     ));
-
     check!(ffi::c_take_vec_u8(&[86_u8, 75_u8, 30_u8, 9_u8].to_vec()));
-
     check!(ffi::c_take_vec_shared(&vec![
         ffi::Shared { z: 1010 },
         ffi::Shared { z: 1011 }
